/*
Copyright 2024 The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	scheme "sigs.k8s.io/node-feature-discovery/api/generated/clientset/versioned/scheme"
	v1alpha1 "sigs.k8s.io/node-feature-discovery/api/nfd/v1alpha1"
)

// NodeFeatureRulesGetter has a method to return a NodeFeatureRuleInterface.
// A group's client should implement this interface.
type NodeFeatureRulesGetter interface {
	NodeFeatureRules() NodeFeatureRuleInterface
}

// NodeFeatureRuleInterface has methods to work with NodeFeatureRule resources.
type NodeFeatureRuleInterface interface {
	Create(ctx context.Context, nodeFeatureRule *v1alpha1.NodeFeatureRule, opts v1.CreateOptions) (*v1alpha1.NodeFeatureRule, error)
	Update(ctx context.Context, nodeFeatureRule *v1alpha1.NodeFeatureRule, opts v1.UpdateOptions) (*v1alpha1.NodeFeatureRule, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NodeFeatureRule, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NodeFeatureRuleList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NodeFeatureRule, err error)
	NodeFeatureRuleExpansion
}

// nodeFeatureRules implements NodeFeatureRuleInterface
type nodeFeatureRules struct {
	*gentype.ClientWithList[*v1alpha1.NodeFeatureRule, *v1alpha1.NodeFeatureRuleList]
}

// newNodeFeatureRules returns a NodeFeatureRules
func newNodeFeatureRules(c *NfdV1alpha1Client) *nodeFeatureRules {
	return &nodeFeatureRules{
		gentype.NewClientWithList[*v1alpha1.NodeFeatureRule, *v1alpha1.NodeFeatureRuleList](
			"nodefeaturerules",
			c.RESTClient(),
			scheme.ParameterCodec,
			"",
			func() *v1alpha1.NodeFeatureRule { return &v1alpha1.NodeFeatureRule{} },
			func() *v1alpha1.NodeFeatureRuleList { return &v1alpha1.NodeFeatureRuleList{} }),
	}
}
